# Nihongo Benkyo
# Copyright (C) 2005 Mathieu Blondel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

module NihongoBenkyo

    TITLE = 'Nihongo Benkyo'
    TEXTDOMAIN = 'nihongobenkyo'
    extend GetText
    bindtextdomain(NihongoBenkyo::TEXTDOMAIN, nil, nil, "UTF-8")
    DESCRIPTION = _('A Japanese dictionary and learning tool.')
    COPYRIGHT = 'Copyright (C) 2005 Mathieu Blondel'
    AUTHORS = [
        'Mathieu Blondel <mblondel AT rubyforge.org>',
        'Jean-Denis Vauguet <jd AT apinc.org>'
    ]
    DOCUMENTERS = [

    ]
    TRANSLATORS = [ 
        'Mathieu Blondel <mblondel AT rubyforge.org> (fr)',
        'David Moreno Garza <damog AT damog.net> (es)',
        'Masao Mutoh <mutoh AT highway.ne.jp> (ja)',
        'Rostislav Raykov <zbrox AT i-space.org> (bg)',
        'Sebastian Herbord <sherb AT gmx.net> (de)'
    ]

    LIST = 'nihongobenkyo-list@rubyforge.org'
    WEBSITE_URL = 'http://www.nihongobenkyo.org'

    SUPPORTED_FORMATS = ['Edict', 'JMDict', 'JMnedict', 'Kanjidic2']
    JMDICT_LANGUAGES = ['de', 'en', 'fr', 'nl', 'ru']
    KANJIDIC2_LANGUAGES = ['en', 'es', 'pt']

    def self.main
        NihongoBenkyo::UI.main
    end
end

require 'nihongobenkyo/config'
require 'nihongobenkyo/version'
require 'nihongobenkyo/romkan'
require 'nihongobenkyo/radicals'
require 'nihongobenkyo/preferences'
require 'nihongobenkyo/database'
require 'nihongobenkyo/ui'
require 'nihongobenkyo/utils'
