# Nihongo Benkyo
# Copyright (C) 2005 Mathieu Blondel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# Based upon:
#
# Ruby/Romkan - a Romaji <-> Kana conversion library for Ruby.
#
# Copyright (C) 2001 Satoru Takabayashi <satoru@namazu.org>
#     All rights reserved.
#     This is free software with ABSOLUTELY NO WARRANTY.
#
# You can redistribute it and/or modify it under the terms of 
# the Ruby's licence.


class Array
    def pairs(s=2)
        0.step(self.size-1,s) do |x| 
            yield self.slice(x,s)
        end
    end
end
        
class String

    HIRAHEPBURNTAB = "\
ぁ       xa      あ       a       ぃ       xi      い       i       ぅ       xu
う       u       う゛      vu      う゛ぁ     va      う゛ぃ     vi      う゛ぇ     ve
う゛ぉ     vo      ぇ       xe      え       e       ぉ       xo      お       o
        

か       ka      が       ga      き       ki      きゃ      kya     きゅ      kyu
きょ      kyo     ぎ       gi      ぎゃ      gya     ぎゅ      gyu     ぎょ      gyo
く       ku      ぐ       gu      け       ke      げ       ge      こ       ko
ご       go      

さ       sa      ざ       za      し       shi     しゃ      sha     しゅ      shu
しょ      sho     じ       ji      じゃ      ja      じゅ      ju      じょ      jo
す       su      ず       zu      せ       se      ぜ       ze      そ       so
ぞ       zo

た       ta      だ       da      ち       chi     ちゃ      cha     ちゅ      chu
ちょ      cho     ぢ       di      ぢゃ      dya     ぢゅ      dyu     ぢょ      dyo

っ       xtsu    
っう゛     vvu     っう゛ぁ    vva     っう゛ぃ    vvi     
っう゛ぇ    vve     っう゛ぉ    vvo     
っか      kka     っが      gga     っき      kki     っきゃ     kkya    
っきゅ     kkyu    っきょ     kkyo    っぎ      ggi     っぎゃ     ggya    
っぎゅ     ggyu    っぎょ     ggyo    っく      kku     っぐ      ggu     
っけ      kke     っげ      gge     っこ      kko     っご      ggo     っさ      ssa
っざ      zza     っし      sshi    っしゃ     ssha    
っしゅ     sshu    っしょ     ssho    
っじ      jji     っじゃ     jja     っじゅ     jju     っじょ     jjo     
っす      ssu     っず      zzu     っせ      sse     っぜ      zze     っそ      sso
っぞ      zzo     った      tta     っだ      dda     っち      cchi    
っちゃ     ccha    っちゅ     cchu    っちょ     ccho    っぢ      ddi     
っぢゃ     ddya    っぢゅ     ddyu    っぢょ     ddyo    っつ      ttsu    
っづ      ddu     って      tte     っで      dde     っと      tto     っど      ddo
っは      hha     っば      bba     っぱ      ppa     っひ      hhi     
っひゃ     hhya    っひゅ     hhyu    っひょ     hhyo    っび      bbi     
っびゃ     bbya    っびゅ     bbyu    っびょ     bbyo    っぴ      ppi     
っぴゃ     ppya    っぴゅ     ppyu    っぴょ     ppyo    っふ      ffu     
っふぁ     ffa     っふぃ     ffi     っふぇ     ffe     っふぉ     ffo     
っぶ      bbu     っぷ      ppu     っへ      hhe     っべ      bbe     っぺ      ppe
っほ      hho     っぼ      bbo     っぽ      ppo     っや      yya     っゆ      yyu
っよ      yyo     っら      rra     っり      rri     っりゃ     rrya    
っりゅ     rryu    っりょ     rryo    っる      rru     っれ      rre     
っろ      rro     

つ       tsu     づ       du      て       te      で       de      と       to
ど       do      

な       na      に       ni      にゃ      nya     にゅ      nyu     にょ      nyo
ぬ       nu      ね       ne      の       no      

は       ha      ば       ba      ぱ       pa      ひ       hi      ひゃ      hya
ひゅ      hyu     ひょ      hyo     び       bi      びゃ      bya     びゅ      byu
びょ      byo     ぴ       pi      ぴゃ      pya     ぴゅ      pyu     ぴょ      pyo
ふ       fu      ふぁ      fa      ふぃ      fi      ふぇ      fe      ふぉ      fo
ぶ       bu      ぷ       pu      へ       he      べ       be      ぺ       pe
ほ       ho      ぼ       bo      ぽ       po      

ま       ma      み       mi      みゃ      mya     みゅ      myu     みょ      myo
む       mu      め       me      も       mo

ゃ       xya     や       ya      ゅ       xyu     ゆ       yu      ょ       xyo
よ       yo      

ら       ra      り       ri      りゃ      rya     りゅ      ryu     りょ      ryo
る       ru      れ       re      ろ       ro      

ゎ       xwa     わ       wa      ゐ       wi      ゑ       we
を       wo      ん       n       

ん     n'
でぃ   dyi
ー     -
ちぇ    che
っちぇ     cche
じぇ      je
"

    KATAHEPBURNTAB = "\
ァ       xa      ア       a       ィ       xi      イ       i       ゥ       xu
ウ       u       ヴ      vu      ヴァ     va      ヴィ     vi      ヴェ     ve
ヴォ     vo      ェ       xe      エ       e       ォ       xo      オ       o
        

カ       ka      ガ       ga      キ       ki      キャ      kya     キュ      kyu
キョ      kyo     ギ       gi      ギャ      gya     ギュ      gyu     ギョ      gyo
ク       ku      グ       gu      ケ       ke      ゲ       ge      コ       ko
ゴ       go      

サ       sa      ザ       za      シ       shi     シャ      sha     シュ      shu
ショ      sho     ジ       ji      ジャ      ja      ジュ      ju      ジョ      jo
ス       su      ズ       zu      セ       se      ゼ       ze      ソ       so
ゾ       zo

タ       ta      ダ       da      チ       chi     チャ      cha     チュ      chu
チョ      cho     ヂ       di      ヂャ      dya     ヂュ      dyu     ヂョ      dyo

ッ       xtsu    
ッヴ     vvu     ッヴァ    vva     ッヴィ    vvi     
ッヴェ    vve     ッヴォ    vvo     
ッカ      kka     ッガ      gga     ッキ      kki     ッキャ     kkya    
ッキュ     kkyu    ッキョ     kkyo    ッギ      ggi     ッギャ     ggya    
ッギュ     ggyu    ッギョ     ggyo    ック      kku     ッグ      ggu     
ッケ      kke     ッゲ      gge     ッコ      kko     ッゴ      ggo     ッサ      ssa
ッザ      zza     ッシ      sshi    ッシャ     ssha    
ッシュ     sshu    ッショ     ssho    
ッジ      jji     ッジャ     jja     ッジュ     jju     ッジョ     jjo     
ッス      ssu     ッズ      zzu     ッセ      sse     ッゼ      zze     ッソ      sso
ッゾ      zzo     ッタ      tta     ッダ      dda     ッチ      cchi    
ッチャ     ccha    ッチュ     cchu    ッチョ     ccho    ッヂ      ddi     
ッヂャ     ddya    ッヂュ     ddyu    ッヂョ     ddyo    ッツ      ttsu    
ッヅ      ddu     ッテ      tte     ッデ      dde     ット      tto     ッド      ddo
ッハ      hha     ッバ      bba     ッパ      ppa     ッヒ      hhi     
ッヒャ     hhya    ッヒュ     hhyu    ッヒョ     hhyo    ッビ      bbi     
ッビャ     bbya    ッビュ     bbyu    ッビョ     bbyo    ッピ      ppi     
ッピャ     ppya    ッピュ     ppyu    ッピョ     ppyo    ッフ      ffu     
ッファ     ffa     ッフィ     ffi     ッフェ     ffe     ッフォ     ffo     
ッブ      bbu     ップ      ppu     ッヘ      hhe     ッベ      bbe     ッペ      ppe
ッホ      hho     ッボ      bbo     ッポ      ppo     ッヤ      yya     ッユ      yyu
ッヨ      yyo     ッラ      rra     ッリ      rri     ッリャ     rrya    
ッリュ     rryu    ッリョ     rryo    ッル      rru     ッレ      rre     
ッロ      rro     

ツ       tsu     ヅ       du      テ       te      デ       de      ト       to
ド       do      

ナ       na      ニ       ni      ニャ      nya     ニュ      nyu     ニョ      nyo
ヌ       nu      ネ       ne      ノ       no      

ハ       ha      バ       ba      パ       pa      ヒ       hi      ヒャ      hya
ヒュ      hyu     ヒョ      hyo     ビ       bi      ビャ      bya     ビュ      byu
ビョ      byo     ピ       pi      ピャ      pya     ピュ      pyu     ピョ      pyo
フ       fu      ファ      fa      フィ      fi      フェ      fe      フォ      fo
ブ       bu      プ       pu      ヘ       he      ベ       be      ペ       pe
ホ       ho      ボ       bo      ポ       po      

マ       ma      ミ       mi      ミャ      mya     ミュ      myu     ミョ      myo
ム       mu      メ       me      モ       mo

ャ       xya     ヤ       ya      ュ       xyu     ユ       yu      ョ       xyo
ヨ       yo      

ラ       ra      リ       ri      リャ      rya     リュ      ryu     リョ      ryo
ル       ru      レ       re      ロ       ro      

ヮ       xwa     ワ       wa      ウィ       wi      ウェ       we
ヲ       wo      ン       n       

ン     n'
ヂィ   dyi
ー     -
チェ    che
ッチェ     cche
ジェ      je
"

    [
        ["HIRAROM", HIRAHEPBURNTAB],
        ["KATAROM", KATAHEPBURNTAB]
    ].each do |kanrom, tab|
        kanaroma = Hash.new
        tab.split(/\s+/).pairs do |x|
            kana, roma = x
            kanaroma[kana] = roma
        end
        const_set(kanrom, kanaroma)
    end

    [
        ["ROMHIRA", HIRAHEPBURNTAB],
        ["ROMKATA", KATAHEPBURNTAB]
    ].each do |romkan, tab|
        romakana = Hash.new
        tab.split(/\s+/).pairs do |x|
            kana, roma = x
            romakana[roma] = kana
        end
        const_set(romkan, romakana)
    end

    [
        ["HIRAPAT", HIRAROM],
        ["KATAPAT", KATAROM]
    ].each do |pat, tab|
        const_set(pat, 
            (tab.keys.sort do |a, b| 
                b.length <=> a.length ||
                tab[a].length <=> tab[b].length
            end.join "|")
        )
    end

    # Sort in long order so that a longer Romaji sequence precedes.
    [
        ["ROMHIRAPAT", ROMHIRA],
        ["ROMKATAPAT", ROMKATA]
    ].each do |pat, tab|
        const_set(pat, (tab.keys.sort {|a, b| b.length <=> a.length}.join "|"))
    end


    # FIXME: ad hod solution
    # tanni   => tan'i
    # kannji  => kanji
    # hannnou => han'nou
    # hannnya => han'nya
    def normalize_double_n
        self.gsub(/nn/, "n'").gsub(/n\'(?=[^aiueoyn]|$)/, "n")
    end

    def normalize_double_n!
        self.gsub!(/nn/, "n'")
        self.gsub!(/n\'(?=[^aiueoyn]|$)/, "n")
        self
    end

    def to_hira
        tmp = self.normalize_double_n
        tmp.gsub(/(#{ROMHIRAPAT})/) { ROMHIRA[$1] }
    end

    def to_kata
        tmp = self.normalize_double_n
        tmp.gsub(/(#{ROMKATAPAT})/) { ROMKATA[$1] }
    end

    def to_roma
        if hiragana?
            tmp = self.gsub(/(#{HIRAPAT})/) { HIRAROM[$1] }
            tmp.gsub(/n'(?=[^aeiuoyn]|$)/, "n")
        elsif katakana?
            tmp = self.gsub(/(#{KATAPAT})/) { KATAROM[$1] }
            tmp.gsub(/n'(?=[^aeiuoyn]|$)/, "n")     
        else
            self
        end       
    end

    def to_hira!
        self.normalize_double_n!
        self.gsub!(/(#{ROMHIRAPAT})/) { ROMHIRA[$1] }
        self
    end

    def to_kata!
        self.normalize_double_n!
        self.gsub!(/(#{ROMKATAPAT})/) { ROMKATA[$1] }
        self
    end

    def to_roma!
        if hiragana?
            self.gsub!(/(#{HIRAPAT})/) { HIRAROM[$1] }
            self.gsub!(/n'(?=[^aeiuoyn]|$)/, "n")
            self
        elsif katakana?
            self.gsub!(/(#{KATAPAT})/) { KATAROM[$1] }
            self.gsub!(/n'(?=[^aeiuoyn]|$)/, "n")
            self
        else
            self
        end
    end

    def consonant?
        if /^[ckgszjtdhfpbmyrwxn]$/.match(self)
        true
        else
        false
        end
    end

    def vowel?
        if /^[aeiou]$/.match(self)
            true
        else
            false
        end
    end

    # `z' => (za ze zi zo zu)
    def expand_consonant 
        ROMHIRA.keys.select do |x|
        /^#{self}.$/ =~ x 
        end
    end
  
  # See http://www.unicode.org/charts/
  
    def kanji?
        self.unpack("U*").each do |char|
            if not ((char >= 0x4E00 and char <= 0x9FBF) or (char >= 0x3400 and char <= 0x4DBF) or
                    (char >= 0x20000 and char <= 0x2A6DF) or (char >= 0x3190 and char <= 0x319F) or
                    (char >= 0xF900 and char <= 0xFAFF) or (char >= 0x2F800 and char <= 0x2FA1F))
                return false 
            end
        end
        return true
    end

    def hiragana?
        self.unpack("U*").each do |char|
            if not (char >= 0x3040 and char <= 0x309F)
                return false
            end
        end
        return true
    end
  
    def katakana?
        self.unpack("U*").each do |char|
            if not (char >= 0x30A0 and char <= 0x30FF)
                return false
            end
        end
        return true
    end
  
    def kana?
        self.hiragana? or self.katakana?
    end
  
    def japanese?
        self.unpack("U*").each do |char|
            if not ((char >= 0x30A0 and char <= 0x30FF) or (char >= 0x3040 and char <= 0x309F) or
                    (char >= 0x4E00 and char <= 0x9FBF) or (char >= 0x3400 and char <= 0x4DBF) or
                    (char >= 0x20000 and char <= 0x2A6DF) or (char >= 0x3190 and char <= 0x319F) or
                    (char >= 0xF900 and char <= 0xFAFF) or (char >= 0x2F800 and char <= 0x2FA1F))
                return false 
            end
        end
        return true
    end

    def latin?
        self.unpack("U*").each do |char|
            if not (char >= 0 and char <= 0x00FF)
                return false 
            end
        end
        return true
    end
  
end

