# Nihongo Benkyo
# Copyright (C) 2005 Mathieu Blondel
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require 'iconv'
require 'MeCab'

class String
    
    def euc_jp_encode
        Iconv.new('euc-jp', 'utf-8').iconv(self)
    end

    def euc_jp_decode
        Iconv.new('utf-8', 'euc-jp').iconv(self)
    end

    def words 
        mecab = MeCab::Tagger.new([""])
        mnode = mecab.parseToNode(self.euc_jp_encode)
        word_array = []

        while mnode.hasNode() != 0 do
            infos = {}           
            infos[:word] = mnode.getSurface.euc_jp_decode
            feature = mnode.getFeature.euc_jp_decode
            array = feature.split(",")
            infos[:type] = array[0]
            infos[:dform] = array[4]
            infos[:reading] = array[5]
            word_array << infos unless infos[:type] == "BOS/EOS"
            mnode = mnode.next()
        end

        word_array
    end

    def each_word
        word_array = self.words
        word_array.each do |i|
            yield i[:word], i[:type], i[:dform], i[:reading]
        end    
    end

end

if __FILE__ == $0
    sentence = "《アパートから近い所だったから、遅くまで踊ってきました。》"
    
    sentence.each_word do |*args|
        args.each do |t|
            print t , "\t"
        end
        print "\n"
    end
end
