-- # Nihongo Benkyo
-- # Copyright (C) 2005 Mathieu Blondel
-- #
-- # This program is free software; you can redistribute it and/or modify
-- # it under the terms of the GNU General Public License as published by
-- # the Free Software Foundation; either version 2 of the License, or
-- # (at your option) any later version.
-- #
-- # This program is distributed in the hope that it will be useful,
-- # but WITHOUT ANY WARRANTY; without even the implied warranty of
-- # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- # GNU General Public License for more details.
-- #
-- # You should have received a copy of the GNU General Public License
-- # along with this program; if not, write to the Free Software
-- # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

CREATE TABLE dictionaries(
    id INTEGER PRIMARY KEY,
    name TEXT,
    type INTEGER,
    selected INTEGER DEFAULT 1,
    position INTEGER
);

CREATE TABLE entries(
    id INTEGER PRIMARY KEY,
    dictionary_id INTEGER
); 

CREATE TABLE kanji(
    id INTEGER PRIMARY KEY,
    entry_id INTEGER,
    kanji TEXT
);

CREATE TABLE readings(
    id INTEGER PRIMARY KEY,
    entry_id INTEGER,
    type TEXT,
    reading TEXT
);

CREATE TABLE translations(
    id INTEGER PRIMARY KEY,
    entry_id INTEGER,
    sense_id INTEGER,
    language TEXT,
    translation TEXT
);

CREATE TABLE metadata_names(
    id INTEGER PRIMARY KEY,
    metadata_of TEXT,
    name TEXT,
    description TEXT
);

CREATE TABLE metadata_values(
    id INTEGER PRIMARY KEY,
    matching_id INTEGER,
    metadata_name_id INTEGER,
    value TEXT
);

--Metadata from JMDict

INSERT INTO metadata_names VALUES (1, "word_kanji", "word_kanji_info", "Informations about the word");
INSERT INTO metadata_names VALUES (2, "word_kanji", "word_kanji_source", "Ressources in which the word has been found");
INSERT INTO metadata_names VALUES (3, "word_kanji", "word_kanji_priority", "Importance of the word");


INSERT INTO metadata_names VALUES (4, "word_reading", "word_reading_no_kanji", "This reading does not correspond to a word in kanji");
INSERT INTO metadata_names VALUES (5, "word_reading", "word_reading_info", "Informations about the reading");
INSERT INTO metadata_names VALUES (6, "word_reading", "word_reading_source", "Ressources in which the reading has been found");
INSERT INTO metadata_names VALUES (7, "word_reading", "word_reading_priority", "Importance of the reading");
INSERT INTO metadata_names VALUES (8, "word_reading", "word_reading_restriction", "Words in kanji to which the reading is restricted");


INSERT INTO metadata_names VALUES (9, "word_entry", "word_entry_origin_lang", "Word originating languages");
INSERT INTO metadata_names VALUES (10, "word_entry", "word_entry_dialect", "Word dialects");
INSERT INTO metadata_names VALUES (11, "word_entry", "word_entry_etymology", "Word etymology explanations");


INSERT INTO metadata_names VALUES (12, "word_sense", "word_sense_kanji_restriction", "Words in kanji to which the translation is restricted");
INSERT INTO metadata_names VALUES (13, "word_sense", "word_sense_reading_restriction", "Readings to which the translation is restricted");
INSERT INTO metadata_names VALUES (14, "word_sense", "word_sense_reference", "Similar or related meanings");
INSERT INTO metadata_names VALUES (15, "word_sense", "word_sense_antonym", "Antonyms");
INSERT INTO metadata_names VALUES (16, "word_sense", "word_sense_part_of_speech", "Part of speech");
INSERT INTO metadata_names VALUES (17, "word_sense", "word_sense_field", "Field of application");
INSERT INTO metadata_names VALUES (18, "word_sense", "word_sense_misc", "Other relevant informations");
INSERT INTO metadata_names VALUES (19, "word_sense", "word_sense_info", "Additional sense informations");
INSERT INTO metadata_names VALUES (20, "word_sense", "word_sense_name_type", "Name type");

--Metadata from Kanjidic2

INSERT INTO metadata_names VALUES (21, "kanji_entry", "kanji_stroke_count", "Stroke count");
INSERT INTO metadata_names VALUES (22, "kanji_entry", "kanji_grade", "Jouyou Kanji grade level");
INSERT INTO metadata_names VALUES (23, "kanji_entry", "kanji_frequency", "Frequency-of-use ranking");